# -*- python -*-

import cgi
from _TutorialBase import *

class formdata(TutorialBase):

    title = 'Processing URL and FORM Data'

    css_links = ['tutorial.css']

    def write_content(self):

        if self.req.method == 'POST':
            self.writeln('Show me the ',
                         A('overview', href=self.req.uri),
                         ' again.')
            
            firstname = self.form.getfirst('firstname')
            age = self.form.getfirst('age')
            div = DIV(klass='formoutput')
            div.append(STRONG('This servlet has been posted via a form:'),
                       BR(),BR(), 'First Name: ', firstname, BR(),'Age: ', age)
            self.writeln(CENTER(div))

        else:
            self.writeln(H3('Nomenclature'),
                         expand_codes(nomenclature))
            
            self.writeln(H3('Retrieving Data'))

            div = DIV(style='margin-left:.5in')
            div.append(

                P('''For each request an instance variable is created,
                  C{form}, and is an instance of
                  C{mod_python.utils.FieldStorage} (refer to the standard
                  mod_python documentation for details).  Here we will
                  briefly show how you can use the C{form} instance
                  variable to retrieve data.'''))
            
            self.writeln(expand_codes(div))

        table = TABLE(klass='formdisplay')
        table.append(TR(TD('First Name: '),
                        TD(INPUT(type='text', name='firstname', value='Bob'))),
                     TR(TD('Age: '),
                        TD(INPUT(type='text', name='age', value='42',
                                 size='4'))),
                     TR(TD(INPUT(type='submit', value='Try Me'),
                           colspan='2', align='center')))
                     
        self.writeln(P(FORM(CENTER(table), method='POST')))



        
nomenclature = DIV(

    A('RFC 2396', href='http://www.ietf.org/rfc/rfc2396.txt'),
    """ refers to the part of a URI to the right of a '?' as the
    query, as in:""",
    
    P(EM(cgi.escape('<scheme>://<authority><path>?<query>')),
      style='margin-left:.5in'),

    P('An example of an HTTP URL with a query:'),
    
    P(EM(cgi.escape('http://somehost/somepath?firstname=Bob&age=42')),
      style='margin-left:.5in'),


    P('''Here we say that E{firstname} and E{age} are S{query
      variables} and that E{Bob} and E{42} are their S{values}.'''),

    P('In HTML FORM elements, as in:'),

    P(EM(cgi.escape('<INPUT type="text" name="firstname">')),
      BR(),
      EM(cgi.escape('<INPUT type="text" name="age">')),
      style='margin-left:.5in'),

    P('''we say E{firstname} and E{age} are S{form variables}, E{iff}
      the form is submitted with method POST.  If the form is
      submitted with method GET, the data will be placed in the URL
      and so we call these S{query variables} as well.'''),

    P('''Why we make this distinction between S{query variables} and
      S{form variables} will be made clear in the next few
      servlets.'''))

nomenclature['style'] = 'margin-left:.5in'
