# -*- python -*-

from _TutorialBase import *

class index(TutorialBase):

    title = 'Hello, world!'

    def write_content(self):
        
        self.writeln('''
    Do not all tutorials start with:

    <h3 style="margin-left:1in">Hello, world!</h3>

    How it works:
    <ul>

      <li> Define a class that is a subclass of
           <code>mod_python.servlet.Servlet</code> and place it in a
           file with the same basename as the class name and with a
           .mps extenstion.

      <li> In your class, override the <code>write_content</code>
           method.

      <li> Make calls to the <code>writeln</code> method which sends
           output to the client browser.

      </ul>

    In the case of this servlet, we have a class named
    <code>index</code> in a file named <strong>index.mps</strong> (the
    handler automatically looks for a file named index.mps if a
    directory is specified).  It subclasses <code>TutorialBase</code>
    (which, trust for now, is ultimately a subclass of
    <code>mod_python.servlet.Servlet</code>).  There is only one
    method, <code>write_content</code> which makes a single call
    to <code>writeln</code> with this text.

    <p>

    This servlet also sets a single instance variable,
    <code>title</code>, which sets the title of this page.

    <p>

    After viewing the python source (click on the link above) you may
    be wondering how the big, centered title got on this page, as well
    as the horizontal rules and the navigation links, etc.  They come
    from the <code>TutorialBase</code> superclass, but do not worry
    about that for now; that will be explained later in this tutorial.
    For now, just know that all the output made by
    <code>write_content</code> with calls to <code>writeln</code> will
    go between the horizontal rules.

    <p>

    If you view the HTML that is generated by the servlet you will
    notice that all the content sent to the browser by
    <code>write_content</code> is placed inside
    &lt;BODY&gt;...&lt;/BODY&gt; tags.  How the rest of the HTML is
    generated and how you can control it will be shown throughout this
    tutorial.

    <p>

    In the next example, you will see what happens when you do not
    override <code>write_content</code>.''')
