# -*- python -*-

from _TutorialBase import *
import time

class sessions(TutorialBase):

      title = 'Sessions'
      css_links = ['tutorial.css']

      use_session = True
      session_timeout = 60 * 3

      def write_content(self):

            self.writeln(expand_codes(overview))

            visits = self.session['visits'] = self.session.get('visits', 0) + 1

            self.writeln(CENTER(
                  DIV('You have visited this page %d time%s.'
                      % (visits, visits > 1 and 's' or ''),
                      self.session.is_new() and ' (new session)' or '',
                      klass='formoutput')))


overview = DIV(

      P('''Mod_python Servlets encapsulates standard mod_python
        sessions.  Each servlet has a C{session} instance variable;
        its value is controlled by the value of another instance
        variable, C{use_session}.  If C{use_session} evaluates to
        C{False} (the default) then sessions are not used and the
        value of the C{session} instance variable will be C{None}.  If
        C{use_session} evaluates to C{True} then the C{session}
        instance variable will be an instance of
        C{mod_python.Session.Session}.  The session timeout is
        controlled by the C{session_timeout} instance variable, which
        is in seconds (default: 1800, or thirty minutes).  Note: the
        session is automatically saved by a servlet with each request,
        so explicit calls to the C{save} method are not
        necessary.'''),

      P('''This servlet demonstrates using sessions with a trivial
        E{how-many-times-have-I-visited-this-page} counter.  Reload
        the page and watch the counter.  Note: this session times out
        after three minutes.'''))


